varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform mediump float intensity;

mediump vec4 clut(mediump vec4 textureColor, sampler2D textureLut) {
    mediump float blueColor = textureColor.b * 31.0;
    
    mediump vec2 quad1;
    quad1.y = floor(floor(blueColor) / 8.0);
    quad1.x = floor(blueColor) - (quad1.y * 8.0);
    
    mediump vec2 quad2;
    quad2.y = floor(ceil(blueColor) / 8.0);
    quad2.x = ceil(blueColor) - (quad2.y * 8.0);
    
    mediump vec2 texPos1;
    texPos1.x = (quad1.x * 0.125) + 0.5/256. + ((0.125 - 1.0/256.) * textureColor.r);
    texPos1.y = (quad1.y * 0.25) + 0.5/128. + ((0.25 - 1.0/128.) * textureColor.g);
    
    mediump vec2 texPos2;
    texPos2.x = (quad2.x * 0.125) + 0.5/256. + ((0.125 - 1.0/256.) * textureColor.r);
    texPos2.y = (quad2.y * 0.25) + 0.5/128. + ((0.25 - 1.0/128.) * textureColor.g);
    
    mediump vec4 newColor1 = texture2D(textureLut, texPos1);
    mediump vec4 newColor2 = texture2D(textureLut, texPos2);
    
    mediump vec4 newColor = mix(newColor1, newColor2, fract(blueColor));
    mediump vec4 resultColor = mix(textureColor, vec4(newColor.rgb, textureColor.w), intensity);
    return resultColor ;
}

void main()
{
    mediump vec4 sourceImageColor = texture2D(inputImageTexture, textureCoordinate);
    gl_FragColor = clut(sourceImageColor, inputImageTexture2);
}
