var WBXNativeElements = [];

var RenderNativeElement = {
  // 测量图片的大小和位置
  measureElementPlaceHolder: function () {
    for(let v of WBXNativeElements){
    if(v.indexOf("picker_") > -1){
       wbox.renderNativePickerView(v.split("_")[1]);
    }else{
            var id = v.split("_")[1]
            var nv = document.querySelector(`[data-wbox-id=wbox-el-${id}]`)
            var left = nv.getBoundingClientRect().left + nv.scrollLeft;
            var top = nv.getBoundingClientRect().top + nv.scrollTop;
            var width = nv.getBoundingClientRect().right - left;
            var height = nv.getBoundingClientRect().bottom - top;
            var src = nv.getAttribute('src')

//            if(v.indexOf("video_") > -1){
//                wbox.renderNativeVideoView(id,left, top, width, height,src);
//            }
        }
    }
  }



}

class NativeElement extends window.Component {
    set id(val) {
        super.id = val
        callMix("createElement",{type:this.wboxTagName,id:`${val}`})
    }

    get id () {
        return super.id
    }

    setAttribute (name, value) {
        this.el.setAttribute(name, value)
        callMix("updateAttributes",{id:`${this._id}`,name,value})
    }
}

class VideoElement extends NativeElement {
    constructor (...args) {
        super(...args)
        this.context = {}
     }

    set id(val){
       super.id = val
        WBXNativeElements.push("video_"+val);

        this.idParam = document.createElement('param')
        this.idParam.setAttribute("name","id")
        this.idParam.setAttribute("value",val)

        this.container.appendChild(this.idParam)
    }

    render () {
        this.container = document.createElement('object')
        this.container.setAttribute("type","application/nativewidget")

        return this.container
    }

    createVideoContext (contextId) {
//        console.log("createVideoContext", contextId)
      }

    method (method, ...args) {
//        console.log("NativeVideoElement", method)
        callMix('videoControls', { id: `${this._id}`, method })
    }
}

//class NativeStatusElement extends NativeElement {
//    set id(val){
//       super.id = val
//        WBXNativeElements.push("status_"+val);
//        this.idParam = document.createElement('param')
//        this.idParam.setAttribute("name","id")
//        this.idParam.setAttribute("value",val)
//
//        this.container.appendChild(this.idParam)
//    }
//
//    render () {
//        this.container = document.createElement('object')
//        this.container.setAttribute("type","application/nativewidget")
//        this.container.addEventListener('heightChange', (options) => {
//             this.container.style.height = options.detail.height
//        })
//        return this.container
//    }
//
//     setAttribute (name, value) {
//            super.setAttribute(name, value)
//        }
//}

class NativeAudioElement extends NativeElement {

    render () {
        this.audio = document.createElement('div')
        this.audio.setAttribute('class','wbox-audio--default')

        this.poster = document.createElement('div')
        this.poster.setAttribute('class','wbox-audio-poster--default')

        this.controls = document.createElement('span')
        this.controls.setAttribute('class','wbox-btn-round--default wbox-btn-background--default wbox-btn--default')
        this.controls.addEventListener('click', (evt)=>{
            callMix('callContext',{id:`${this._id}`,eventname:'click'})
        })

        this.img = document.createElement('img')

        this.playicon = document.createElement('div')
        this.playicon.setAttribute('class','wbox-audio-pause-icon--default')

        this.audio.addEventListener('pause', (evt)=>{
            if (this.playicon.classList.contains('wbox-audio-pause-icon--default')) {
                this.playicon.classList.remove('wbox-audio-pause-icon--default')
            };
            if (!this.playicon.classList.contains('wbox-audio-play-icon--default')) {
                this.playicon.classList.add('wbox-audio-play-icon--default')
            };
        })
        this.audio.addEventListener('play', (evt)=>{
            if (this.playicon.classList.contains('wbox-audio-play-icon--default')) {
                this.playicon.classList.remove('wbox-audio-play-icon--default')
            };
            if (!this.playicon.classList.contains('wbox-audio-pause-icon--default')) {
                this.playicon.classList.add('wbox-audio-pause-icon--default')
            };
        })
        this.audio.addEventListener('ended', (evt)=>{
            if (this.playicon.classList.contains('wbox-audio-pause-icon--default')) {
                this.playicon.classList.remove('wbox-audio-pause-icon--default')
            };
            if (!this.playicon.classList.contains('wbox-audio-play-icon--default')) {
                this.playicon.classList.add('wbox-audio-play-icon--default')
            };
        })

        this.audioinfo = document.createElement('div')
        this.audioinfo.setAttribute('class','wbox-audio-info--default')

        this.infotitle = document.createElement('span')
        this.infotitle.setAttribute('class','wbox-audio-title--default')

        this.infoname = document.createElement('span')
        this.infoname.setAttribute('class','wbox-audio-name--default')

        this.audiotime = document.createElement('div')
        this.audiotime.setAttribute('class','wbox-audio-time--default')

        this.audiotimespan = document.createElement('span')
        this.audiotimespan.setAttribute('class','wbox-audio-num--default')
        this.audiotimespan.innerText = '00:00'

        this.audioinfo.appendChild(this.infotitle)
        this.audioinfo.appendChild(this.infoname)

        this.audiotime.appendChild(this.audiotimespan)

        this.controls.appendChild(this.playicon)
        this.poster.appendChild(this.controls)
        this.poster.appendChild(this.img)

        this.audio.appendChild(this.poster)
        this.audio.appendChild(this.audioinfo)
        this.audio.appendChild(this.audiotime)

        return this.audio
    }

    setAttribute (name, value) {
        if (name === 'poster') {
            this.img.setAttribute('src',value)
        } else if (name === 'title') {
            this.infotitle.innerText = value
        } else if (name === 'name') {
            this.infoname.innerText = value
        } else if (name === 'time') {
            this.audiotimespan.innerText = value
        } else {
            super.setAttribute(name, value)
        };
    }

}



class NativePickerElement extends NativeElement {
    set id(val){
       super.id = val
        WBXNativeElements.push("picker_"+val);

    }

    render () {
        this.container = document.createElement('div')
        this.container.addEventListener('click', (evt)=>{
                    callMix('callContext',{id:`${this._id}`,eventname:'click'})
                })

        return this.container
    }
}

class WBVideoElement extends NativeElement {
  render () {
    this.audio = document.createElement('div')

        this.poster = document.createElement('div')
        this.poster.setAttribute('class', 'wbox-video-poster--default')

        this.controls = document.createElement('span')
        this.controls.setAttribute('class', 'wbox-video-controls--default')

        this.img = document.createElement('img')
        this.img.setAttribute('class', 'wbox-poster-img--default')
        this.img.style.width = '100%'
        this.img.style.height = '100%'

        this.audio.addEventListener('click', () => {
          const top = this.audio.offsetTop
          const left = this.audio.offsetLeft
          const width = this.audio.offsetWidth
          const height = this.audio.offsetHeight
          callMix('callContext', { id: `${this._id}`, eventname: 'click', frame: { top, left, width, height }})
        })

        this.playicon = document.createElement('div')
        this.playicon.setAttribute('class', 'wbox-video-play-icon--default')

        this.audio.addEventListener('imageChange', (options) => {
          this.img.setAttribute('src', options.detail.img)
        })
        this.controls.appendChild(this.playicon)
        this.poster.appendChild(this.controls)
        this.poster.appendChild(this.img)
        this.audio.appendChild(this.poster)
        return this.audio
  }

  setAttribute (name, value) {
    if (name === 'imgWidth') {
      this.audio.style.width = value
    } else if (name === 'imgHeight') {
      this.audio.style.height = value
    } else {
      super.setAttribute(name, value)
    }
  }
}

class RichTextElement extends NativeElement{
     render () {
        this.container = document.createElement('richtext')
        return this.container
     }
     appendChild(child){
        this.el.appendChild(child.el || child)
        var text = child.el.textContent
        callMix('parserEmotion',{id:`${this._id}`,text})
     }

    insertBefore(child, ref){
        this.el.insertBefore(child.el, ref.el)
        var text = child.el.textContent
        callMix('parserEmotion',{id:`${this._id}`,text})
     }
}

window.ComponentManager.registerComponents({});

function callMix(name, data){
    wbox.callMix(JSON.stringify({name,data}))
}

function fireMixEvent(id, type, data){
    let el = document.querySelector(`[data-wbox-id=wbox-el-${id}]`)
    let event = document.createEvent('HTMLEvents')
    //冒泡、阻止浏览器默认行为
    event.initEvent(type,true,true)
    event.detail = data
    el.dispatchEvent(event)

}

function renderEmotion(id, text){
    let el = document.querySelector(`[data-wbox-id=wbox-el-${id}]`)
    el.innerHTML = text
}
