"use strict";

function _instanceof(left, right) { if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) { return !!right[Symbol.hasInstance](left); } else { return left instanceof right; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!_instanceof(instance, Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function set(target, property, value, receiver) { if (typeof Reflect !== "undefined" && Reflect.set) { set = Reflect.set; } else { set = function set(target, property, value, receiver) { var base = _superPropBase(target, property); var desc; if (base) { desc = Object.getOwnPropertyDescriptor(base, property); if (desc.set) { desc.set.call(receiver, value); return true; } else if (!desc.writable) { return false; } } desc = Object.getOwnPropertyDescriptor(receiver, property); if (desc) { if (!desc.writable) { return false; } desc.value = value; Object.defineProperty(receiver, property, desc); } else { _defineProperty(receiver, property, value); } return true; }; } return set(target, property, value, receiver); }

function _set(target, property, value, receiver, isStrict) { var s = set(target, property, value, receiver || target); if (!s && isStrict) { throw new Error('failed to set property'); } return value; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var WBXNativeElements = [];
var RenderNativeElement = {
  // 测量图片的大小和位置
  measureElementPlaceHolder: function measureElementPlaceHolder() {
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = WBXNativeElements[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var v = _step.value;

        if (v.indexOf("picker_") > -1) {
          wbox.renderNativePickerView(v.split("_")[1]);
        } else {
          var id = v.split("_")[1];
          var nv = document.querySelector("[data-wbox-id=wbox-el-".concat(id, "]"));
          var left = nv.getBoundingClientRect().left + nv.scrollLeft;
          var top = nv.getBoundingClientRect().top + nv.scrollTop;
          var width = nv.getBoundingClientRect().right - left;
          var height = nv.getBoundingClientRect().bottom - top;
          var src = nv.getAttribute('src'); //            if(v.indexOf("video_") > -1){
          //                wbox.renderNativeVideoView(id,left, top, width, height,src);
          //            }
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }
};

var NativeElement =
/*#__PURE__*/
function (_window$Component) {
  _inherits(NativeElement, _window$Component);

  function NativeElement() {
    _classCallCheck(this, NativeElement);

    return _possibleConstructorReturn(this, _getPrototypeOf(NativeElement).apply(this, arguments));
  }

  _createClass(NativeElement, [{
    key: "setAttribute",
    value: function setAttribute(name, value) {
      this.el.setAttribute(name, value);
      callMix("updateAttributes", {
        id: "".concat(this._id),
        name: name,
        value: value
      });
    }
  }, {
    key: "id",
    set: function set(val) {
      _set(_getPrototypeOf(NativeElement.prototype), "id", val, this, true);

      callMix("createElement", {
        type: this.wboxTagName,
        id: "".concat(val)
      });
    },
    get: function get() {
      return _get(_getPrototypeOf(NativeElement.prototype), "id", this);
    }
  }]);

  return NativeElement;
}(window.Component);

var VideoElement =
/*#__PURE__*/
function (_NativeElement) {
  _inherits(VideoElement, _NativeElement);

  function VideoElement() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, VideoElement);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(VideoElement)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.context = {};
    return _this;
  }

  _createClass(VideoElement, [{
    key: "render",
    value: function render() {
      this.container = document.createElement('object');
      this.container.setAttribute("type", "application/nativewidget");
      return this.container;
    }
  }, {
    key: "createVideoContext",
    value: function createVideoContext(contextId) {//        console.log("createVideoContext", contextId)
    }
  }, {
    key: "method",
    value: function method(_method) {
      //        console.log("NativeVideoElement", method)
      callMix('videoControls', {
        id: "".concat(this._id),
        method: _method
      });
    }
  }, {
    key: "id",
    set: function set(val) {
      _set(_getPrototypeOf(VideoElement.prototype), "id", val, this, true);

      WBXNativeElements.push("video_" + val);
      this.idParam = document.createElement('param');
      this.idParam.setAttribute("name", "id");
      this.idParam.setAttribute("value", val);
      this.container.appendChild(this.idParam);
    }
  }]);

  return VideoElement;
}(NativeElement);

var NativeAudioElement =
/*#__PURE__*/
function (_NativeElement2) {
  _inherits(NativeAudioElement, _NativeElement2);

  function NativeAudioElement() {
    _classCallCheck(this, NativeAudioElement);

    return _possibleConstructorReturn(this, _getPrototypeOf(NativeAudioElement).apply(this, arguments));
  }

  _createClass(NativeAudioElement, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      this.audio = document.createElement('div');
      this.audio.setAttribute('class', 'wbox-audio--default');
      this.poster = document.createElement('div');
      this.poster.setAttribute('class', 'wbox-audio-poster--default');
      this.controls = document.createElement('span');
      this.controls.setAttribute('class', 'wbox-btn-round--default wbox-btn-background--default wbox-btn--default');
      this.controls.addEventListener('click', function (evt) {
        callMix('callContext', {
          id: "".concat(_this2._id),
          eventname: 'click'
        });
      });
      this.img = document.createElement('img');
      this.playicon = document.createElement('div');
      this.playicon.setAttribute('class', 'wbox-audio-pause-icon--default');
      this.audio.addEventListener('pause', function (evt) {
        if (_this2.playicon.classList.contains('wbox-audio-pause-icon--default')) {
          _this2.playicon.classList.remove('wbox-audio-pause-icon--default');
        }

        ;

        if (!_this2.playicon.classList.contains('wbox-audio-play-icon--default')) {
          _this2.playicon.classList.add('wbox-audio-play-icon--default');
        }

        ;
      });
      this.audio.addEventListener('play', function (evt) {
        if (_this2.playicon.classList.contains('wbox-audio-play-icon--default')) {
          _this2.playicon.classList.remove('wbox-audio-play-icon--default');
        }

        ;

        if (!_this2.playicon.classList.contains('wbox-audio-pause-icon--default')) {
          _this2.playicon.classList.add('wbox-audio-pause-icon--default');
        }

        ;
      });
      this.audio.addEventListener('ended', function (evt) {
        if (_this2.playicon.classList.contains('wbox-audio-pause-icon--default')) {
          _this2.playicon.classList.remove('wbox-audio-pause-icon--default');
        }

        ;

        if (!_this2.playicon.classList.contains('wbox-audio-play-icon--default')) {
          _this2.playicon.classList.add('wbox-audio-play-icon--default');
        }

        ;
      });
      this.audioinfo = document.createElement('div');
      this.audioinfo.setAttribute('class', 'wbox-audio-info--default');
      this.infotitle = document.createElement('span');
      this.infotitle.setAttribute('class', 'wbox-audio-title--default');
      this.infoname = document.createElement('span');
      this.infoname.setAttribute('class', 'wbox-audio-name--default');
      this.audiotime = document.createElement('div');
      this.audiotime.setAttribute('class', 'wbox-audio-time--default');
      this.audiotimespan = document.createElement('span');
      this.audiotimespan.setAttribute('class', 'wbox-audio-num--default');
      this.audiotimespan.innerText = '00:00';
      this.audioinfo.appendChild(this.infotitle);
      this.audioinfo.appendChild(this.infoname);
      this.audiotime.appendChild(this.audiotimespan);
      this.controls.appendChild(this.playicon);
      this.poster.appendChild(this.controls);
      this.poster.appendChild(this.img);
      this.audio.appendChild(this.poster);
      this.audio.appendChild(this.audioinfo);
      this.audio.appendChild(this.audiotime);
      return this.audio;
    }
  }, {
    key: "setAttribute",
    value: function setAttribute(name, value) {
      if (name === 'poster') {
        this.img.setAttribute('src', value);
      } else if (name === 'title') {
        this.infotitle.innerText = value;
      } else if (name === 'name') {
        this.infoname.innerText = value;
      } else if (name === 'time') {
        this.audiotimespan.innerText = value;
      } else {
        _get(_getPrototypeOf(NativeAudioElement.prototype), "setAttribute", this).call(this, name, value);
      }

      ;
    }
  }]);

  return NativeAudioElement;
}(NativeElement);

var NativePickerElement =
/*#__PURE__*/
function (_NativeElement3) {
  _inherits(NativePickerElement, _NativeElement3);

  function NativePickerElement() {
    _classCallCheck(this, NativePickerElement);

    return _possibleConstructorReturn(this, _getPrototypeOf(NativePickerElement).apply(this, arguments));
  }

  _createClass(NativePickerElement, [{
    key: "render",
    value: function render() {
      var _this3 = this;

      this.container = document.createElement('div');
      this.container.addEventListener('click', function (evt) {
        callMix('callContext', {
          id: "".concat(_this3._id),
          eventname: 'click'
        });
      });
      return this.container;
    }
  }, {
    key: "id",
    set: function set(val) {
      _set(_getPrototypeOf(NativePickerElement.prototype), "id", val, this, true);

      WBXNativeElements.push("picker_" + val);
    }
  }]);

  return NativePickerElement;
}(NativeElement);

var WBVideoElement =
/*#__PURE__*/
function (_NativeElement4) {
  _inherits(WBVideoElement, _NativeElement4);

  function WBVideoElement() {
    _classCallCheck(this, WBVideoElement);

    return _possibleConstructorReturn(this, _getPrototypeOf(WBVideoElement).apply(this, arguments));
  }

  _createClass(WBVideoElement, [{
    key: "render",
    value: function render() {
      var _this4 = this;

      this.audio = document.createElement('div');
      this.poster = document.createElement('div');
      this.poster.setAttribute('class', 'wbox-video-poster--default');
      this.controls = document.createElement('span');
      this.controls.setAttribute('class', 'wbox-video-controls--default');
      this.img = document.createElement('img');
      this.img.setAttribute('class', 'wbox-poster-img--default');
      this.img.style.width = '100%';
      this.img.style.height = '100%';
      this.audio.addEventListener('click', function () {
        var top = _this4.audio.offsetTop;
        var left = _this4.audio.offsetLeft;
        var width = _this4.audio.offsetWidth;
        var height = _this4.audio.offsetHeight;
        callMix('callContext', {
          id: "".concat(_this4._id),
          eventname: 'click',
          frame: {
            top: top,
            left: left,
            width: width,
            height: height
          }
        });
      });
      this.playicon = document.createElement('div');
      this.playicon.setAttribute('class', 'wbox-video-play-icon--default');
      this.audio.addEventListener('imageChange', function (options) {
        _this4.img.setAttribute('src', options.detail.img);
      });
      this.controls.appendChild(this.playicon);
      this.poster.appendChild(this.controls);
      this.poster.appendChild(this.img);
      this.audio.appendChild(this.poster);
      return this.audio;
    }
  }, {
    key: "setAttribute",
    value: function setAttribute(name, value) {
      if (name === 'imgWidth') {
        this.audio.style.width = value;
      } else if (name === 'imgHeight') {
        this.audio.style.height = value;
      } else {
        _get(_getPrototypeOf(WBVideoElement.prototype), "setAttribute", this).call(this, name, value);
      }
    }
  }]);

  return WBVideoElement;
}(NativeElement);

var RichTextElement =
/*#__PURE__*/
function (_NativeElement5) {
  _inherits(RichTextElement, _NativeElement5);

  function RichTextElement() {
    _classCallCheck(this, RichTextElement);

    return _possibleConstructorReturn(this, _getPrototypeOf(RichTextElement).apply(this, arguments));
  }

  _createClass(RichTextElement, [{
    key: "render",
    value: function render() {
      this.container = document.createElement('richtext');
      return this.container;
    }
  }, {
    key: "appendChild",
    value: function appendChild(child) {
      this.el.appendChild(child.el || child);
      var text = child.el.textContent;
      callMix('parserEmotion', {
        id: "".concat(this._id),
        text: text
      });
    }
  }, {
    key: "insertBefore",
    value: function insertBefore(child, ref) {
      this.el.insertBefore(child.el, ref.el);
      var text = child.el.textContent;
      callMix('parserEmotion', {
        id: "".concat(this._id),
        text: text
      });
    }
  }]);

  return RichTextElement;
}(NativeElement);

window.ComponentManager.registerComponents({});

function callMix(name, data) {
  wbox.callMix(JSON.stringify({
    name: name,
    data: data
  }));
}

function fireMixEvent(id, type, data) {
  var el = document.querySelector("[data-wbox-id=wbox-el-".concat(id, "]"));
  var event = document.createEvent('HTMLEvents'); //冒泡、阻止浏览器默认行为

  event.initEvent(type, true, true);
  event.detail = data;
  el.dispatchEvent(event);
}

function renderEmotion(id, text) {
  var el = document.querySelector("[data-wbox-id=wbox-el-".concat(id, "]"));
  el.innerHTML = text;
}